######################
## Exercise 2
## Lecture 6 
## Mixed Models intro
###################### 


# MM for individuals with records

# response
 y <- c(4.5,2.9,3.9,3.5,5.0)

# pedigree
I<-diag(5)

# variance component ratio
 
vcr = 40/20
 
# X matrix
X <- matrix(c(1,0,0,1,1,0,1,1,0,0), nrow=5, ncol=2)

# Z matrix

#z1 <- matrix(0, ncol=3, nrow=5)
#z2 <-#matrix(c(1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1), ncol=5)
#Z <- cbind(z1,z2)
#Z

Z<-diag(5)

Xpy <- t(X)%*%y
Zpy <- t(Z)%*%y
XpX <- t(X)%*% X
XpZ <- t(X)%*%Z
ZpX <- t(Z)%*%X
ZpZ <- t(Z)%*%Z
 
LHS <- rbind( cbind(XpX, XpZ), cbind(ZpX, ZpZ+I*vcr))
RHS <- c(Xpy, Zpy)

sol<-solve(LHS,RHS)
SE<-sqrt(diag(solve(LHS)*40))

LHSin<-solve(LHS)

dC22<-diag(LHSin[-c(1:2),-c(1:2)])

r2<-1- dC22*vcr


r<-sqrt(r2)



##### Solutions for individuals without records

# response
 y <- c(4.5,2.9,3.9,3.5,5.0)

# pedigree
I<-diag(8)

# variance component ratio
 
vcr = 40/20
 
# X matrix
X <- matrix(c(1,0,0,1,1,0,1,1,0,0), nrow=5, ncol=2)

# Z matrix

z1 <- matrix(0, ncol=3, nrow=5)
z2 <-matrix(c(1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1), ncol=5)
Z <- cbind(z1,z2)
Z


Xpy <- t(X)%*%y
Zpy <- t(Z)%*%y
XpX <- t(X)%*% X
XpZ <- t(X)%*%Z
ZpX <- t(Z)%*%X
ZpZ <- t(Z)%*%Z
 
LHS <- rbind( cbind(XpX, XpZ), cbind(ZpX, ZpZ+I*vcr))
RHS <- c(Xpy, Zpy)

sol<-solve(LHS,RHS)
SE<-sqrt(diag(solve(LHS)*40))

LHSin<-solve(LHS)

dC22<-diag(LHSin[-c(1:2),-c(1:2)])

r2<-1- dC22*vcr


r<-sqrt(r2)


##### BLUP with pedigree

Ainv<-matrix(c(1.833,.05,0,-0.667,0,-1,0,0,
.5,2,.5,0,-1,-1,0,0,0,.5,2,0,-1,.5,0,-1,-.667,0,0,01.833,.5,0,-1,0,0,-1,-1,.5,2.5,0,-1,0,-1,-1,.5,0,0,2.5,0,-1,0,0,0,-1,-1,0,2,0, 0,0,-1,0,0,-1,0,2), ncol=8)


Xpy <- t(X)%*%y
Zpy <- t(Z)%*%y
XpX <- t(X)%*% X
XpZ <- t(X)%*%Z
ZpX <- t(Z)%*%X
ZpZ <- t(Z)%*%Z
 
LHS <- rbind( cbind(XpX, XpZ), cbind(ZpX, ZpZ+Ainv*vcr))
RHS <- c(Xpy, Zpy)

