library(MASS)


######## Our y

y=c(122,
113,
124,
112,
132,
98,
132,
121,
134,
145,
121)

# X
X=matrix(c(1,	1,	0,	0,	0,	1,
1,	1,	0,	0,	1,	0,
1,	1,	0,	0,	0,	1,
1,	1,	0,	0,	1,	0,
1,	0,	1,	0,	0,	1,
1,	0,	1,	0,	1,	0,
1,	0,	1,	0,	0,	1,
1,	0,	1,	0,	1,	0,
1,	0,	0,	1,	0,	1,
1,	0,	0,	1,	1,	0,
1,	0,	0,	1,	0,	1), 11,byrow=T)

# Z  
Z=matrix(
 c(1,	0,	0,	0,	0,
 0,	1,	0,	0,	0,
 1,	0,	0,	0,	0,
 0,	1,	0,	0,	0,
 0,	0,	1,	0,	0,
 0,	0,	1,	0,	0,
 0,	0,	1,	0,	0,
 0,	0,	0,	1,	0,
 0,	0,	0,	0,	0,
 0,	0,	0,	0,	1,
 0,	0,	0,	0,	1), 11, byrow=T)


# G and R
I1=diag(5)
I2=diag(11)
se=25
su=15

G=I1*su
R=I2*se


Zt=t(Z)
Xt=t(X)


####### Using the inverse of the variance
V=Z%*%(su*I1)%*%Zt+(se*I2)
Vinv=solve(V)

### solving
b=ginv(t(X)%*%Vinv%*%X)%*%(t(X)%*%Vinv%*%y)
u=(su*I1)%*%Zt%*%Vinv%*%(y-X%*%b)





# Using Henderson's equations

alpha=se/su
XpX=crossprod(X)
XpZ=crossprod(X,Z)
ZpX=crossprod(Z,X)
ZpZ=crossprod(Z)
Xpy=crossprod(X,y)
Zpy=crossprod(Z,y)

## LHS

LHS=rbind(cbind(XpX,XpZ),cbind(ZpX,ZpZ+alpha))
RHS=rbind(Xpy,Zpy)

sol=ginv(LHS)%*%RHS


